import java.io.*;

public class DataTable {
	private RandomAccessFile dbfile; 
	private int rc; 
	private int recordLength = 42; 
	private int recordOffset = 4; 
	
	public DataTable(String file) { 
		try { 
			dbfile = new RandomAccessFile(file, "rw"); 
			if(dbfile.length() ==0) { 
				rc = 0; 
			} else {  
				rc = dbfile.readInt();
			} 
		} catch(IOException e) { 
			System.out.println(e);
		} 
	} 
	
	public int length() { 
		return rc; 
	} 
	
	public void add(String name, int num, String part, String tel) { 
		writeRec(name, num, part, tel, rc++); 
	} 
	
	public void close() { 
		try {
			dbfile.setLength(recordLength*rc + recordOffset);
			dbfile.close(); 
		} catch(IOException ioe) {
			System.out.println(ioe);
		}
	} 
	
	public Record readRec(int index) { 
		String name="", part="", tel="" ; 
		int    num = -1 ; 
		
		try {
			dbfile.seek(index * recordLength + recordOffset); 
			for(int i = 0; i < 5; i++)  { 
				name += dbfile.readChar(); 
			} 
			
			num = dbfile.readInt(); 
			
			for(int i = 0; i < 6;i++) { 
				part += dbfile.readChar(); 
			} 
			
			for(int i = 0; i < 8;i++)  { 
				tel  += dbfile.readChar(); 
			} 			
		} catch(IOException ioe) {
			System.out.println(ioe);
		}
		return (new Record(name, num, part, tel)); 
	} 
	
	public String readName(int index, int len) { 
		String name=""; 
		try {
			dbfile.seek(index * recordLength + recordOffset); 
			for(int i = 0; i < len;i++)  { 
				name += dbfile.readChar(); 
			} 
		} catch (IOException ioe) {
			System.out.println(ioe);
		}
		return name; 
	} 
	
	public void remove(int i) {
		try {
			rc = i; 			
			dbfile.seek(0); 
			dbfile.writeInt(rc);
			dbfile.setLength(recordLength*rc + recordOffset);
		} catch(IOException ioe) {
			System.out.println(ioe);
		}
	} 
	
	public void writeRec(String name, int num, String part, 
			String tel, int index) { 
		int len = 0; 

		try { 
			dbfile.seek(index * recordLength + recordOffset); 
			len = name.length(); 
			for(int i =0; i < 5; i++) { 
				dbfile.writeChar((i < len ? name.charAt(i):' '));
			} 
			
			dbfile.writeInt(num); 
			
			len = part.length(); 
			for(int i =0;i < 6;i++) { 
				dbfile.writeChar((i< len ? part.charAt(i):' ')); 
			} 
			
			len = tel.length(); 
			for(int i =0;i < 8;i++) { 
				dbfile.writeChar((i< len ? tel.charAt(i):' '));
			} 
			
			dbfile.seek(0);
			dbfile.writeInt(rc);
		} catch(IOException ioe) {
			System.out.println(ioe);
		} 
	} 
}
