import java.awt.*; 
import javax.swing.*;
import java.awt.event.*; 
 
//public class EmployeeDB extends JFrame
public class EmployeeDB extends JApplet
	implements ActionListener { 

	// 6 lines
	static final int NONE   = 0;
	static final int ADD    = 1;
	static final int TOTAL  = 2;
	static final int SEARCH = 3;
	static final int REMOVE = 4;
	static final int ESC    = 5;

	private JPanel   left, bottom;
	private JTextField  name, number, dept, phone;
	private JTextArea  display;
	private JButton      addB, totalB, searchB;
	private JButton      removeB, escB, exitB;	
	private DataTable   table;
	//private CMD          action;
	int		action;
  
	public EmployeeDB(String dbFile) { 
		//super("EmployeeDB"); 
		//action = CMD.NONE;
		action = NONE;

		makeLeft();
		makeBottom();
		display = new JTextArea();
		display.setEditable(false);
		getContentPane().add("Center", new JScrollPane(display));
		initialize();
		
		table = new DataTable(dbFile);
	//	setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		setSize(550, 300);
		setVisible(true);
	}
	
	private void makeLeft() {
		left = new JPanel();		
		name = new JTextField();	
		number = new JTextField();	
		dept = new JTextField();	
		phone = new JTextField();	
		left.setLayout(new GridLayout(4, 2, 5, 35));
		left.setPreferredSize(new Dimension(150, 300));
		left.add(new JLabel(" "));
		left.add(name);
		left.add(new JLabel(" "));		
		left.add(number);
		left.add(new JLabel(" "));
		left.add(dept);
		left.add(new JLabel(" ȭ"));
		left.add(phone);
		getContentPane().add("West", left);		
	}
	
	private void makeBottom() {
		bottom = new JPanel(new GridLayout(1,6,10, 10));		
		addB = new JButton(" ");		
		addB.addActionListener(this);
		totalB = new JButton(" ü");		
		totalB.addActionListener(this);
		searchB = new JButton(" ");		
		searchB.addActionListener(this);
		removeB = new JButton(" ");		
		removeB.addActionListener(this);
		escB = new JButton(" ");		
		escB.addActionListener(this);
		exitB = new JButton(" ");		
		exitB.addActionListener(this);
		bottom.add(addB);
		bottom.add(totalB);
		bottom.add(searchB);
		bottom.add(removeB);
		bottom.add(escB);
		bottom.add(exitB);		
		getContentPane().add("South", bottom);		
	}

	private void initialize() {
		//action = CMD.NONE;
		action = NONE;
		setEditable(false);
		clear();
		setEnable(true);
	}
	private void setEditable(boolean v) {
		name.setEditable(v);
		number.setEditable(v);
		dept.setEditable(v);
		phone.setEditable(v);		
	}
	
	private void clear() {
		name.setText("");
		number.setText("");
		dept.setText("");
		phone.setText("");		
	}
	
	private void setEnable(boolean v) {
		addB.setEnabled(v);
		totalB.setEnabled(v);
		searchB.setEnabled(v);
		removeB.setEnabled(v);		
	}
	
	public void actionPerformed(ActionEvent e) {
		Object o = e.getSource();
		if(o == addB) { 
			add();
		} else if(o == totalB) {
			total();
		} else if(o == searchB) {
			search();
		} else if(o == removeB) {
			remove();
		} else if(o == escB) {
			//action = CMD.NONE;
			action = NONE;
			initialize();
		} else if(o == exitB) {
			table.close();
			System.exit(0);
		}
	} 
	
	private void add() {
		String nameString, num, part, tel;		
		//if( action != CMD.ADD) {
		//	action = CMD.ADD;
		if( action != ADD) {
			action = ADD;
			setEditable(true);
			setEnable(false);
			addB.setEnabled(true);
			return;
		}
		
		if(hasValue(name) && hasValue(number) 
				&& hasValue(dept) != true) {
			return;
		}
		nameString = name.getText().trim(); 
		num  = number.getText().trim(); 
		part = dept.getText().trim(); 
		tel = phone.getText().trim(); 

		display.setText(nameString + num + part + tel);
		table.add(nameString, Integer.parseInt(num), part, tel);
		display.append("\n   ƽϴ.");
		initialize();				
	}
	
	private boolean hasValue(JTextField t) {
		String data = t.getText().trim();
		if(data.length() == 0){
			return false;
		}
		return true;
	}

	private void total() {
		//action = CMD.TOTAL;
		action = TOTAL;
		int len = table.length();           
		display.setText("\n ˻ Ǽ :  " + len + " \n"); 
		display.append("\n================================="); 
		display.append("\n   \t   \t   \tμ   \tȭ");  
		display.append("\n=================================\n");
		if(len == 0) {
			display.append(" ϵ ڷᰡ ϴ. \n"); 
			return;
		}
		for(int i = 0; i < len; i++) { 
			Record rec = table.readRec(i);
			print(i, rec.getName(), rec.getNum(), 
					rec.getPart(), rec.getTel());
		}		
	}
	
	private void print(int i, String name, int num, 
			String dept, String tel) {
		display.append(Integer.toString(i+1) + "  \t ");
		display.append(name + " \t");
		display.append(Integer.toString(num) + " \t");
		display.append(dept + " \t");
		display.append(tel + " \n");		
	}
	
	private void search() {
		String nameString;
		boolean found = false;
		
		//if(action != CMD.SEARCH) {
		//	action = CMD.SEARCH;
		if(action != SEARCH) {
			action = SEARCH;
			setEnable(false);
			name.setEditable(true);
			searchB.setEnabled(true);
			return;
		}
		Record  rec;
		int len = table.length();
		if(hasValue(name) != true){
			return;
		}
		nameString = name.getText().trim();
		display.setText("\n ##  ȸ ###########\n");
		display.append("\n=================================="); 
		display.append("\n   \t   \t   \tμ   \tȭ");  
		display.append("\n=================================\n\n"); 
		for(int i = 0; i < len ; i++) { 
			rec = table.readRec(i);
			if(nameString.equals(table.readName(i, 
					nameString.length()))) {
				found = true;
				print(i, rec.getName(), rec.getNum(), 
						rec.getPart(), rec.getTel());
			}
		}
		if (!found) {
			display.setText(" ȸϽ  ϴ."); 
		}
		initialize();		
	}
	
	private void remove() {
		String nameString;
		boolean found = false;
		
		//if(action != CMD.REMOVE) {
		//	action = CMD.REMOVE;
		if(action != REMOVE) {
			action = REMOVE;
			setEnable(false);
			name.setEditable(true);
			removeB.setEnabled(true);
			return;
		}
		int len = table.length();
		if(hasValue(name) != true){
			return;
		}		
		nameString = name.getText().trim();
		display.setText("\n ##  ###########\n");
		display.append("\n=================================");
		display.append("\n   \t   \t   \tμ   \tȭ");  
		display.append("\n=================================\n\n");
		for(int i = 0; i < len ; i++) {
			Record rec = table.readRec(i);
			if(nameString.equals(table.readName(i, 
					nameString.length()))) {  // ̸  ڵ带 ã´.
				found = true;
			}
			if(found) {
				print(i, rec.getName(), rec.getNum(), 
						rec.getPart(), rec.getTel());
				found = true;
				display.append("\n  ڷḦ Ͽϴ.");
				// i°  ڵ带 ϳ Ʒ ̵Ѵ.
				for(int k = i+1 ; k < len; k++) {  
					rec = table.readRec(k);
					table.writeRec(rec.getName(), rec.getNum(),
							rec.getPart(), rec.getTel(), k-1);
				}
				table.remove(--len);
				break;
			}
		}
		if(!found) {
			display.append("ȸϽ  ϴ.");
		}
		initialize();		
	}
	 
	//public static void main(String agrs[]) {
	public void init(){
		new EmployeeDB("employee.db");
	}
}
